/*********************************************************************
 *
 * HDUS.C
 *
 * nnc4hdus̃\[XpĂ܂̂Ő͂ɏ]ĉB
 *
 * ̗ƂĂ
 * EHDUS_CreateŊǗ̈mۂ
 * EHDUS_OpenŘ^Jn
 * EHDUS_CloseŘ^~
 * EHDUS_DeleteŊǗ̈J
 *
 **********************************************************************/


/*
 *
 */
#include "UUSB.C"


/*--------------------------------------------------------------------
 * 萔̒`
 *--------------------------------------------------------------------*/


/*
 *
 */
#define SA_E2PROM          0xA8
#define SA_ASIE5606        0x5A
#define SA_ASIE5606_NEW    0x4A
#define SA_TUNER           0x20


/*
 *
 */
#define HDUS_TRANS_SIZE     (1 << 16)
#define HDUS_RING_SIZE      (HDUS_TRANS_SIZE << 2)
#define HDUS_PACKET_SIZE    188


/*
 *
 */
#define HDUS_CODE_00    0x00
#define HDUS_CODE_01    0x01
#define HDUS_CODE_02    0x02
#define HDUS_CODE_03    0x03
#define HDUS_CODE_04    0x04
#define HDUS_CODE_05    0x05
#define HDUS_CODE_06    0x06
#define HDUS_CODE_07    0x07
#define HDUS_CODE_08    0x08
#define HDUS_CODE_09    0x09
#define HDUS_CODE_0A    0x0A
#define HDUS_CODE_0C    0x0C
#define HDUS_CODE_0D    0x0D
#define HDUS_CODE_0E    0x0E
#define HDUS_CODE_10    0x10
#define HDUS_CODE_17    0x17


/*
 *
 */
#define _xx_    0 /* NULLp[^ */


/*--------------------------------------------------------------------
 * ^̒`
 *--------------------------------------------------------------------*/


/*
 * foCXǗ\
 */
typedef struct {
    /* ReadFileExp */
    DWORD  Internal;
    DWORD  InternalHigh;
    DWORD  Offset;
    DWORD  OffsetHigh;
    HANDLE hEvent;
    /* */
    HANDLE UUSB;        /* UUSBD̃nh */
    BYTE   CDB[256];    /* R}hpobt@ */
    /* Xbh֌W */
    HANDLE FilePC;      /* PC̃t@C */
    HANDLE FileUS;      /* HDUS̃t@C */
    HANDLE Thread;      /* Xbhnh */
    /* obt@֌W */
    BYTE   *Buffer;     /* mۗp̃|C^ */
    BYTE   *Packet;     /* pPbgobt@ */
    BYTE   *Ring;       /* Oobt@ */
    BYTE   *Work;       /* ƃobt@ */
    DWORD  Block;       /* o͂ubN̐ */
    DWORD  RR_Foot;     /* Oobt@̓ǂݏoʒu(O) */
    DWORD  RR_Head;     /* Oobt@̓ǂݏoʒu() */
    DWORD  RR_Lack;     /* ǂݏosf[^ */
    DWORD  WW_Head;     /* Oobt@݈̏ʒu */
    /* */
    BYTE   ASIE;        /* ݂ASIE̔ԍ */
    BYTE   Crypt;       /* ݂ASIEŎgpÍ[h */
    BYTE   Sync;        /* L */
    BYTE   Key[0x10];
    WORD   MaskStart;
    WORD   MaskEnd;
} HDUS_DEVICE;


/*--------------------------------------------------------------------
 * O[oϐ̒`
 *--------------------------------------------------------------------*/


/*
 *
 */
BYTE HDUSV_TunerAddr[0x5C] = {
    0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07, 0x08,
    0x0C, 0x11, 0x12, 0x13, 0x14, 0x15, 0x16, 0x17,
    0x18, 0x19, 0x1A, 0x1B, 0x1C, 0x1D, 0x1E, 0x1F,
    0x20, 0x21, 0x22, 0x23, 0x24, 0x25, 0x26, 0x27,
    0x28, 0x29, 0x2A, 0x2B, 0x2C, 0x2D, 0x2E, 0x2F,
    0x30, 0x31, 0x32, 0x34, 0x38, 0x39, 0x3A, 0x3B,
    0x3C, 0x3D, 0x3E, 0x3F, 0x40, 0x41, 0x42, 0x43,
    0x44, 0x46, 0x47, 0x48, 0x49, 0x4A, 0x4B, 0x4C,
    0x50, 0x51, 0x52, 0x54, 0x55, 0x56, 0x57, 0x58,
    0x5C, 0x5D, 0x5F, 0x70, 0x71, 0x72, 0x75, 0x76,
    0x77, 0x7C, 0x7D, 0xBA, 0xBB, 0xBC, 0xC2, 0xC7,
    0xE4, 0xE9, 0xEC, 0xEF
};


/*
 *
 */
BYTE HDUSV_TunerData[0x5C] = {
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x21, 0x0B, 0x2C, 0x0A, 0x40, 0x0A, 0x70,
    0x31, 0x13, 0x31, 0x13, 0x2A, 0xAA, 0xA2, 0x08,
    0x00, 0xFF, 0x80, 0x4C, 0x4C, 0x00, 0x00, 0x0C,
    0x60, 0x6B, 0x40, 0x40, 0xFF, 0x00, 0xFF, 0x00,
    0x28, 0x0F, 0xA0, 0x3F, 0x01, 0x70, 0x2D, 0x21,
    0x3F, 0x10, 0x08, 0x0C, 0x0C, 0x00, 0x00, 0x4F,
    0xFF, 0x20, 0x00, 0x90, 0xE6, 0x02, 0x54, 0x00,
    0x00, 0x58, 0x20, 0x57, 0xF1, 0x20, 0x70, 0x60,
    0x50, 0x00, 0x80, 0x18, 0x00, 0x00, 0x22, 0x00,
    0x01, 0x00, 0x52, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x1A, 0x08, 0x00, 0x00
};


/*--------------------------------------------------------------------
 * ֐̒`
 *--------------------------------------------------------------------*/


/*
 * Ǘ̈̊J
 */
void HDUS_Delete(HANDLE hHDUS)
{
    HDUS_DEVICE *lpHDUS;

    if (hHDUS == 0) {
        return;
    }
    lpHDUS = (HDUS_DEVICE *) hHDUS;
    CloseHandle(lpHDUS->FilePC);
    CloseHandle(lpHDUS->FileUS);
    CloseHandle(lpHDUS->Thread);
    UUSB_Delete(lpHDUS->UUSB);
    FreeMemory(lpHDUS->Buffer);
    FreeMemory(lpHDUS);
}


/*
 * Ǘ̈̊m
 */
HANDLE HDUS_Create(void)
{
    HDUS_DEVICE *lpHDUS;

    /* HDUSǗ̈mۂ */
    lpHDUS = AllocMemory(sizeof(HDUS_DEVICE));
    if (lpHDUS == 0) {
        return(0);
    }
    ZeroMemory(lpHDUS, sizeof(HDUS_DEVICE));
    /* obt@mۂ */
    lpHDUS->Buffer = AllocMemory(HDUS_RING_SIZE + HDUS_PACKET_SIZE + (HDUS_TRANS_SIZE * 2));
    if (lpHDUS->Buffer == 0) {
        FreeMemory(lpHDUS);
        return(0);
    }
    /* UUSBǗ̈mۂ */
    lpHDUS->UUSB = UUSB_Create();
    if (lpHDUS->UUSB == 0) {
        HDUS_Delete((HANDLE) lpHDUS);
        return(0);
    }
    /* UUSBfoCXJ */
    if (!UUSB_Open(lpHDUS->UUSB, 0x3275, 0x6051)) {
        HDUS_Delete((HANDLE) lpHDUS);
        return(0);
    }
    /* obt@敪 */
    lpHDUS->Ring   = lpHDUS->Buffer;
    lpHDUS->Packet = lpHDUS->Ring + HDUS_RING_SIZE;
    lpHDUS->Work   = lpHDUS->Packet + HDUS_PACKET_SIZE;
    /* o̓Xbh */
    lpHDUS->FilePC = INVALID_HANDLE_VALUE;
    lpHDUS->FileUS = INVALID_HANDLE_VALUE;
    lpHDUS->Thread = INVALID_HANDLE_VALUE;
    /* ̑ */
    lpHDUS->ASIE      = SA_ASIE5606;
    lpHDUS->Crypt     = 0x91;
    lpHDUS->MaskStart = 0x1FFF;
    lpHDUS->MaskEnd   = 0x1FFF;
    lpHDUS->Sync      = 0x47; /* L */
    return((HANDLE) lpHDUS);
}


/*--------------------------------------------------------------------
 * ֐̒`(^Xbh)
 *--------------------------------------------------------------------*/


/*
 * pPbg̕
 */
void HDUS_DecryptA(void *lpDst, void *lpSrc);
void HDUS_DecryptB(void *lpDst, void *lpSrc);
#include "DECRYPT.C"


/*
 * ^XbhpR[obN
 */
void CALLBACK HDUS_RecordCallback(DWORD dwErrorCode, DWORD dwTransfered, HDUS_DEVICE *lpHDUS)
{
    BYTE  *lpPacket;    /* pPbgobt@ */
    BYTE  *lpRing;      /* Oobt@ */
    BYTE  *lpWork;      /* ƃobt@ */
    BYTE  *lpWrite;
    BYTE  bCrypt;
    BYTE  bSync;
    DWORD dwBlock;
    DWORD dwCount;
    DWORD dwFoot;
    DWORD dwHead;
    DWORD dwIndex;
    DWORD dwSize;

    if ((lpHDUS->FilePC == INVALID_HANDLE_VALUE) || (lpHDUS->FileUS == INVALID_HANDLE_VALUE) || (lpHDUS->Thread == INVALID_HANDLE_VALUE)) {
        return;
    }
    lpPacket = lpHDUS->Packet;
    lpRing   = lpHDUS->Ring;
    lpWork   = lpHDUS->Work;
    /* ̎Mo^ */
    dwHead          = (lpHDUS->WW_Head + HDUS_TRANS_SIZE) & (HDUS_RING_SIZE - 1);
    lpHDUS->WW_Head = dwHead;
    ReadFileEx(lpHDUS->FileUS, lpRing + dwHead, HDUS_TRANS_SIZE, (LPOVERLAPPED) lpHDUS, (LPOVERLAPPED_COMPLETION_ROUTINE) HDUS_RecordCallback);
    /*  */
    bCrypt  = lpHDUS->Crypt;
    bSync   = lpHDUS->Sync;
    dwBlock = lpHDUS->Block;
    dwFoot  = lpHDUS->RR_Foot;
    dwHead  = lpHDUS->RR_Head;
    dwCount = HDUS_TRANS_SIZE;
    lpWrite = lpWork;
    /* ȑOAǂݏof[^sꍇ */
    dwSize = lpHDUS->RR_Lack;
    if (dwSize) {
        dwHead         += dwSize;
        dwCount        -= dwSize;
        lpHDUS->RR_Lack = 0;
    }
    while (dwCount) {
        /* Aďo邱Ƃm߂ */
        if (
            (lpRing[dwHead] == bSync)
            && (lpRing[(dwHead + HDUS_PACKET_SIZE * 1) & (HDUS_RING_SIZE - 1)] == bSync)
            && (lpRing[(dwHead + HDUS_PACKET_SIZE * 2) & (HDUS_RING_SIZE - 1)] == bSync)
            && (lpRing[(dwHead + HDUS_PACKET_SIZE * 3) & (HDUS_RING_SIZE - 1)] == bSync)
            /* && (lpRing[(dwHead + HDUS_PACKET_SIZE * 4) & (HDUS_RING_SIZE - 1)] == bSync) */
            /* && (lpRing[(dwHead + HDUS_PACKET_SIZE * 5) & (HDUS_RING_SIZE - 1)] == bSync) */
            /* && (lpRing[(dwHead + HDUS_PACKET_SIZE * 6) & (HDUS_RING_SIZE - 1)] == bSync) */
            /* && (lpRing[(dwHead + HDUS_PACKET_SIZE * 7) & (HDUS_RING_SIZE - 1)] == bSync) */
            ) {
            /* O񂩂獡܂ł𕜍ďo */
            dwSize = (dwHead - dwFoot) & (HDUS_RING_SIZE - 1);
            if (dwSize < HDUS_TRANS_SIZE) {
                while (dwSize >= HDUS_PACKET_SIZE) {
                    dwSize -= HDUS_PACKET_SIZE;
                    for (dwIndex = 0; dwIndex < HDUS_PACKET_SIZE; dwIndex++) {
                        lpPacket[dwIndex] = lpRing[dwFoot++];
                        dwFoot           &= (HDUS_RING_SIZE - 1);
                    }
                    if (*(DWORD *) lpPacket) {
                        if (lpPacket[0] != bSync) {
                            PrintLog1("/* BROKEN BLOCK %d\r\n", dwBlock);
                            BinaryLog(lpPacket, HDUS_PACKET_SIZE);
                            PrintLog0(" */\r\n");
                            /* DӓIɓꂽƂ݂Ȃĕ */
                            lpPacket[0] = bSync;
                        }
                        if (bCrypt == 0x80) {
                            HDUS_DecryptA(lpWrite, lpPacket);
                        }
                        else {
                            HDUS_DecryptB(lpWrite, lpPacket);
                        }
                        lpWrite += HDUS_PACKET_SIZE;
                        dwBlock++;
                    }
                }
                /* S~ꍇ */
                if (dwSize) {
                    for (dwIndex = 0; dwIndex < dwSize; dwIndex++) {
                        lpPacket[dwIndex] = lpRing[dwFoot++];
                        dwFoot           &= (HDUS_RING_SIZE - 1);
                    }
                    PrintLog1("/* DUST OF BLOCK %d\r\n", dwBlock - 1);
                    BinaryLog(lpPacket, dwSize);
                    PrintLog0(" */\r\n");
                }
            }
            dwFoot = dwHead;
            if (dwCount >= HDUS_PACKET_SIZE) {
                dwHead  += HDUS_PACKET_SIZE;
                dwCount -= HDUS_PACKET_SIZE;
            }
            else {
                lpHDUS->RR_Lack = HDUS_PACKET_SIZE - dwCount;
                dwHead         += dwCount;
                dwCount         = 0;
            }
        }
        else {
            dwHead++;
            dwCount--;
        }
    }
    dwHead         &= (HDUS_RING_SIZE - 1);
    lpHDUS->Block   = dwBlock;
    lpHDUS->RR_Head = dwHead;
    lpHDUS->RR_Foot = dwFoot;
    /*  */
    dwSize = lpWrite - lpWork;
    if (dwSize) {
        WriteFile(lpHDUS->FilePC, lpWork, dwSize, &dwSize, 0);
    }
}


/*
 * ^Xbh
 */
DWORD WINAPI HDUS_RecordThread(HDUS_DEVICE *lpHDUS)
{
    lpHDUS->Block   = 0;
    lpHDUS->RR_Foot = 0;
    lpHDUS->RR_Head = 0;
    lpHDUS->RR_Lack = 0;
    lpHDUS->WW_Head = HDUS_TRANS_SIZE * 1;
    ReadFileEx(lpHDUS->FileUS, lpHDUS->Ring, HDUS_TRANS_SIZE * 2, (LPOVERLAPPED) lpHDUS, (LPOVERLAPPED_COMPLETION_ROUTINE) HDUS_RecordCallback);
    while ((lpHDUS->FilePC != INVALID_HANDLE_VALUE) && (lpHDUS->FileUS != INVALID_HANDLE_VALUE) && (lpHDUS->Thread != INVALID_HANDLE_VALUE)) {
        SleepEx(INFINITE, TRUE);
    }
    return(0);
}


/*--------------------------------------------------------------------
 * ֐̒`(悭g𕪗)
 *--------------------------------------------------------------------*/


/*
 * R[h̔s
 */
BOOL HDUS_Control(HANDLE hHDUS, BYTE bCode, BYTE bParam0, BYTE bParam1, BYTE bParam2, BYTE bParam3, WORD wResultSize)
{
    BOOL        bResult;
    HDUS_DEVICE *lpHDUS;
    WORD        wIndex;
    WORD        wValue;

    if (hHDUS == 0) {
        return(FALSE);
    }
    lpHDUS  = (HDUS_DEVICE *) hHDUS;
    wValue  = bParam0 + (bParam1 << 8);
    wIndex  = bParam2 + (bParam3 << 8);
    bResult = UUSB_VendorRequest(lpHDUS->UUSB, bCode, wValue, wIndex, wResultSize, lpHDUS->CDB);
    /* O */
    PrintLog6("CODE(%02X) PARAM(%02X,%02X,%02X,%02X) RESULT_SIZE(%d)\r\n", bCode, bParam0, bParam1, bParam2, bParam3, wResultSize);
    BinaryLog(lpHDUS->CDB, wResultSize);
    return(bResult);
}


/*
 * EFCg
 */
void HDUS_Wait(DWORD dwMilliseconds)
{
    Sleep(dwMilliseconds);
}


/*
 * p[It
 */
void HDUS_PowerOff(HANDLE hHDUS)
{
    PrintLog0("/* BEGIN PowerOff */\r\n");
    HDUS_Wait(50);
    HDUS_Control(hHDUS, HDUS_CODE_08, 0x00, 0x01, _xx_, _xx_, 1);
    HDUS_Wait(100);
    HDUS_Control(hHDUS, HDUS_CODE_08, 0x0C, 0xDD, _xx_, _xx_, 1);
    HDUS_Wait(100);
    PrintLog0("/* END PoweOff */\r\n");
}


/*
 * `[i[N
 */
void HDUS_StartTuner(HANDLE hHDUS)
{
    PrintLog0("/* BEGIN StartTuner */\r\n");
    HDUS_Control(hHDUS, HDUS_CODE_08, 0x00, 0xD5, _xx_, _xx_, 1);
    HDUS_Wait(50);
    HDUS_Control(hHDUS, HDUS_CODE_08, 0x00, 0x08, _xx_, _xx_, 1);
    HDUS_Control(hHDUS, HDUS_CODE_08, 0x40, 0x40, _xx_, _xx_, 1);
    HDUS_Wait(5);
    HDUS_Control(hHDUS, HDUS_CODE_08, 0x80, 0x80, _xx_, _xx_, 1);
    HDUS_Wait(50);
    HDUS_Control(hHDUS, HDUS_CODE_08, 0x04, 0x04, _xx_, _xx_, 1);
    HDUS_Wait(50);
    PrintLog0("/* END StartTuner */\r\n");
}


/*
 * `[i[
 */
void HDUS_InitTuner(HANDLE hHDUS)
{
    long nIndex;

    PrintLog0("/* BEGIN InitTuner */\r\n");
    HDUS_Control(hHDUS, HDUS_CODE_02, SA_E2PROM, 0x00, _xx_, _xx_, 2);
    for (nIndex = 0; nIndex < sizeof(HDUSV_TunerAddr); nIndex++) {
        HDUS_Control(hHDUS, HDUS_CODE_03, SA_TUNER, HDUSV_TunerAddr[nIndex], HDUSV_TunerData[nIndex], _xx_, 2);
    }
    HDUS_Control(hHDUS, HDUS_CODE_02, SA_E2PROM, 0x00, _xx_, _xx_, 2);
    PrintLog0("/* END InitTuner */\r\n");
}


/*
 * ASIEN
 */
void HDUS_StartASIE(HANDLE hHDUS)
{
    PrintLog0("/* BEGIN StartASIE */\r\n");
    HDUS_Control(hHDUS, HDUS_CODE_08, 0xFF, 0x11, _xx_, _xx_, 1); /* bit4ASIE5606bit0̓J[h肩H */
    HDUS_Wait(50);
    HDUS_Control(hHDUS, HDUS_CODE_08, 0x00, 0x11, _xx_, _xx_, 1);
    HDUS_Wait(50);
    HDUS_Control(hHDUS, HDUS_CODE_08, 0xFF, 0x11, _xx_, _xx_, 1);
    HDUS_Wait(100);
    PrintLog0("/* END StartASIE */\r\n");
}


/*
 * `l̐ݒ
 */
void HDUS_SetChannel(HANDLE hHDUS, long nChannel, BOOL bCable)
{
    BYTE  bParam[7];
    DWORD dwFreq;
    DWORD dwVal0;
    DWORD dwVal1;
    DWORD dwVal2;
    DWORD dwVal3;
    DWORD temp;

    PrintLog0("/* BEGIN SetChannel */\r\n");
    if (bCable) {
        dwFreq = 303000 + (nChannel - 36) * 6000;
    }
    else {
        dwFreq = 473000 + (nChannel - 13) * 6000;
    }
    dwFreq += 57000;
    /* */
    dwVal0 = 0x1C;
    dwVal1 = 0x75;
    dwVal2 = 0x0000015E;
    dwVal3 = 0x6A;
    /* */
    if (dwFreq < 0x0003FC17) {
        dwVal1 = 0x76;
        dwVal2 = 0x0000015E;
    }
    else
    if (dwFreq < 0x00044267) {
        dwVal1 = 0x73;
        dwVal2 = 0x0000015E;
    }
    else
    if (dwFreq < 0x000747D7) {
        dwVal1 = 0x73;
        dwVal2 = 0x0000015E;
    }
    else
    if (dwFreq < 0x0008073F) {
        dwVal1 = 0x75;
        dwVal2 = 0x0000015E;
    }
    else
    if (dwFreq < 0x000A83F7) {
        dwVal1 = 0x75;
        dwVal2 = 0x0000015E;
    }
    else {
        dwVal1 = 0x75;
        dwVal2 = 0x0000015E;
    }
    /* */
    temp      = (dwFreq * dwVal0 + 1999) / 4000;
    bParam[0] = 0xFE;
    bParam[1] = 0xC0;
    bParam[2] = (temp >> 8) & 0x7F;
    bParam[3] = temp & 0xFF;
    bParam[4] = 0x80;
    bParam[5] = 0;
    bParam[6] = 0xE3;
    /* */
    switch (dwVal0) {
    case 0x18:
        bParam[4] |= 0;
        break;
    case 0x1C:
        bParam[4] |= 1;
        break;
    case 0x32:
        bParam[4] |= 2;
        break;
    case 0x40:
        bParam[4] |= 3;
        break;
    case 0x50:
        bParam[4] |= 5;
        break;
    case 0x80:
        bParam[4] |= 4;
        break;
    default:
        bParam[4] |= 1;
        break;
    }
    /* */
    switch (dwVal1) {
    case 0x73:
        bParam[5] |= 2;
        break;
    case 0x75:
        bParam[5] |= 4;
        break;
    case 0x76:
        bParam[5] |= 1;
        break;
    default:
        bParam[5] |= 4;
        break;
    }
    /* */
    switch (dwVal2) {
    case 0x046:
        bParam[5] |= 0x00;
        break;
    case 0x08C:
        bParam[5] |= 0x40;
        break;
    case 0x15E:
        bParam[5] |= 0x80;
        break;
    case 0x258:
        bParam[5] |= 0xc0;
        break;
    default:
        bParam[5] |= 0x80;
        break;
    }
    /* */
    switch (dwVal3) {
    case 0x5E:
        bParam[4] |= 0x30;
        break;
    case 0x61:
        bParam[4] |= 0x28;
        break;
    case 0x64:
        bParam[4] |= 0x20;
        break;
    case 0x67:
        bParam[4] |= 0x18;
        break;
    case 0x6A:
        bParam[4] |= 0x10;
        break;
    case 0x6D:
        bParam[4] |= 0x08;
        break;
    case 0x70:
        bParam[4] |= 0x00;
        break;
    default:
        bParam[4] |= 0x10;
        break;
    }
    /* */
    HDUS_Wait(50);
    HDUS_Control(hHDUS, HDUS_CODE_0D, 0x00, bParam[0], bParam[1], bParam[2], 4);
    HDUS_Control(hHDUS, HDUS_CODE_0D, 0x03, bParam[3], bParam[4], bParam[5], 4);
    HDUS_Control(hHDUS, HDUS_CODE_0D, 0x06, bParam[6], _xx_, _xx_, 2);
    HDUS_Control(hHDUS, HDUS_CODE_0E, SA_TUNER, _xx_, _xx_, _xx_, 8);
    HDUS_Control(hHDUS, HDUS_CODE_03, SA_TUNER, 0x01, 0x40, _xx_, 2);
    PrintLog0("/* END SetChannel */\r\n");
}


/*--------------------------------------------------------------------
 * ֐̒`(^JnE~)
 *--------------------------------------------------------------------*/


/*
 * ^Jn
 */
BOOL HDUS_Open(HANDLE hHDUS, char *lpFileName, long nChannel, BOOL bCable)
{
    BYTE        *lpResult;
    DWORD       temp;
    HDUS_DEVICE *lpHDUS;

    PrintLog0("/* BEGIN Open */\r\n");
    if (hHDUS == 0) {
        PrintLog0("/* END Open */\r\n");
        return(FALSE);
    }
    lpHDUS = (HDUS_DEVICE *) hHDUS;
    /* */
    CloseHandle(lpHDUS->FilePC);
    CloseHandle(lpHDUS->FileUS);
    CloseHandle(lpHDUS->Thread);
    /* */
    lpHDUS->FilePC = OpenFileW(lpFileName);
    if (lpHDUS->FilePC == INVALID_HANDLE_VALUE) {
        goto LABEL_ERROR;
    }
    lpHDUS->FileUS = UUSB_OpenPipe(lpHDUS->UUSB, 0, 0);
    if (lpHDUS->FileUS == INVALID_HANDLE_VALUE) {
        goto LABEL_ERROR;
    }
    /* */
    lpResult = lpHDUS->CDB;
    /* (~) */
    HDUS_Control(hHDUS, HDUS_CODE_0C, _xx_, _xx_, _xx_, _xx_, 58);
    HDUS_Control(hHDUS, HDUS_CODE_17, 0x02, _xx_, _xx_, _xx_, 3);
    HDUS_Control(hHDUS, HDUS_CODE_08, 0x07, 0xFB, _xx_, _xx_, 1);
    HDUS_Control(hHDUS, HDUS_CODE_10, 0x00, 0x02, _xx_, _xx_, 1);
    HDUS_PowerOff(hHDUS);
    /* (ċN) */
    HDUS_Control(hHDUS, HDUS_CODE_17, 0x02, _xx_, _xx_, _xx_, 3);
    HDUS_StartTuner(hHDUS);
    HDUS_InitTuner(hHDUS);
    /* ASIE̎ނ̒ƁAΉÍ[ȟ */
    HDUS_StartASIE(hHDUS);
    HDUS_Control(hHDUS, HDUS_CODE_02, lpHDUS->ASIE, 0x09, _xx_, _xx_, 2);
    if (lpResult[0] != 1) {
        lpHDUS->ASIE = SA_ASIE5606_NEW;
        HDUS_Control(hHDUS, HDUS_CODE_02, lpHDUS->ASIE, 0x09, _xx_, _xx_, 2);
        if (lpResult[0] != 1) {
            HDUS_Wait(50);
            HDUS_PowerOff(hHDUS);
            goto LABEL_ERROR;
        }
    }
    if ((lpResult[1] & 7) == 6) {
        lpHDUS->Crypt = 0x80;
    }
    /* 8000.b6ǂݏo */
    /* lpResult[1]1̏ꍇ̓nCXs[h(USB2)A0̏ꍇ̓tXs[h(USB1)ł */
    /* ASV5211̓nCXs[h */
    HDUS_Control(hHDUS, HDUS_CODE_0A, _xx_, _xx_, _xx_, _xx_, 1);
    HDUS_Wait(30);
    /* ASIEÍ[hݒ肷 */
    HDUS_Control(hHDUS, HDUS_CODE_03, lpHDUS->ASIE, 0x05, lpHDUS->Crypt, _xx_, 2);
    HDUS_SetChannel(hHDUS, nChannel, bCable);
    HDUS_Control(hHDUS, HDUS_CODE_09, 0x00, 0x01, _xx_, _xx_, 1);
    /* pPbgIDtB^ݒ肷 */
    HDUS_Control(hHDUS, HDUS_CODE_04, 0x40, _xx_, _xx_, _xx_, 2);
    HDUS_Control(hHDUS, HDUS_CODE_05, 0x40, lpResult[1] | 0x0F, _xx_, _xx_, 2);
    HDUS_Control(hHDUS, HDUS_CODE_05, 0x41, (BYTE) (lpHDUS->MaskStart >> 8), (BYTE) lpHDUS->MaskStart, _xx_, 3);
    HDUS_Control(hHDUS, HDUS_CODE_05, 0x43, (BYTE) (lpHDUS->MaskEnd >> 8), (BYTE) lpHDUS->MaskEnd, _xx_, 3);
    /* ASIE5606ÍL[ݒ肷 */
    /* lpHDUS->Keyɂ͉ݒ肵ĂȂ̂ŁAS0ɂ邱ƂɂȂ܂ */
    for (temp = 0; temp < 0x10; temp++) {
        HDUS_Control(hHDUS, HDUS_CODE_03, lpHDUS->ASIE, 0x10 + temp, lpHDUS->Key[temp], _xx_, 2);
    }
    /* ASV5211bulk]͂߂ */
    HDUS_Control(hHDUS, HDUS_CODE_06, _xx_, _xx_, _xx_, _xx_, 1);
    /* ^XbhJn */
    lpHDUS->Thread = CreateThread(0, 0, (void *) HDUS_RecordThread, (void *) lpHDUS, 0, &temp);
    if (lpHDUS->Thread == INVALID_HANDLE_VALUE) {
        goto LABEL_ERROR;
    }
    SetThreadPriority(lpHDUS->Thread, THREAD_PRIORITY_TIME_CRITICAL);
    PrintLog0("/* END Open */\r\n");
    return(TRUE);
  LABEL_ERROR:
    CloseHandle(lpHDUS->FilePC);
    CloseHandle(lpHDUS->FileUS);
    CloseHandle(lpHDUS->Thread);
    lpHDUS->FilePC = INVALID_HANDLE_VALUE;
    lpHDUS->FileUS = INVALID_HANDLE_VALUE;
    lpHDUS->Thread = INVALID_HANDLE_VALUE;
    PrintLog0("/* END Open */\r\n");
    return(FALSE);
}


/*
 * ^~
 */
void HDUS_Close(HANDLE hHDUS)
{
    HDUS_DEVICE *lpHDUS;

    PrintLog0("/* BEGIN Close */\r\n");
    if (hHDUS == 0) {
        PrintLog0("/* END Close */\r\n");
        return;
    }
    lpHDUS = (HDUS_DEVICE *) hHDUS;
    /* Xbh~ */
    CloseHandle(lpHDUS->FilePC);
    CloseHandle(lpHDUS->FileUS);
    CloseHandle(lpHDUS->Thread);
    lpHDUS->FilePC = INVALID_HANDLE_VALUE;
    lpHDUS->FileUS = INVALID_HANDLE_VALUE;
    lpHDUS->Thread = INVALID_HANDLE_VALUE;
    /* */
    HDUS_Wait(100);
    /* ASV5211bulk]߂悤 */
    HDUS_Control(hHDUS, HDUS_CODE_07, 0, 0, 0, 0, 1);
    HDUS_Control(hHDUS, HDUS_CODE_09, 0, 1, 0, 0, 1);
    HDUS_Control(hHDUS, HDUS_CODE_03, lpHDUS->ASIE, 0x80, 0, 0, 2);
    HDUS_Control(hHDUS, HDUS_CODE_03, lpHDUS->ASIE, 0x04, 0, 0, 2);
    HDUS_Control(hHDUS, HDUS_CODE_03, lpHDUS->ASIE, 0x00, 0, 0, 2);
    HDUS_Wait(50);
    HDUS_PowerOff(hHDUS);
    PrintLog0("/* END Close */\r\n");
}
